#include "Windows.h"
#include <Python.h>
#include <string>


#include   <iostream>
#include   <iomanip>

typedef void *LPVOID;

using namespace std;


#define COUTPUT cout<<"--"

/* module functions */
static PyObject *                                 /* returns object */
createEvent(PyObject *self, PyObject *args)           /* self unused in modules */
{       
	/* args from python call */
    LPSECURITY_ATTRIBUTES lpReserved;
	BOOL bManualReset;
	BOOL bInitialState;
	LPCTSTR lpName;
	HANDLE eventHandle;
    
	cout << "\n--In function createEvent." << endl;


    if (! PyArg_Parse(args, "(kkks)", &lpReserved,&bManualReset,&bInitialState, &lpName))  /* convert Python -> C */
	{
		COUTPUT << "Parse parameters of createEvent error!" << endl;
        return NULL;                              /* null=raise exception */
	}

	COUTPUT << "lpReserved : " << "0x" << hex << lpReserved \
		<< " | bManualReset : "  << bManualReset \
		<< " | bInitialState : " << bInitialState \
		<< " | lpName : " << lpName << endl;

	if ( string(lpName) == "NULL")
	{
		COUTPUT << "change the value of the parameter lpName to 0 " << endl;
		lpName = 0;  
	}

    COUTPUT << "call CreateEvent" << endl;
    eventHandle = CreateEvent(lpReserved, bManualReset, bInitialState, lpName);
	COUTPUT << "return eventHandle is " << eventHandle << endl;
    return Py_BuildValue("k", eventHandle);        /* convert C -> Python */
    
}


static PyObject *                                
resetEvent(PyObject *self, PyObject *args)          
{       
    
	HANDLE eventHandle;
	BOOL   result;
    
	cout << "\n--In function resetEvent." << endl;


    if (! PyArg_Parse(args, "(k)", &eventHandle))  /* convert Python -> C */
	{
		COUTPUT << "Parse parameters of resetEvent error!" << endl;
        return NULL;                              /* null=raise exception */
	}

	COUTPUT << "eventHandle : " << "0x" << hex << eventHandle << endl;

    COUTPUT << "call ResetEvent" << endl;
    result = ResetEvent(eventHandle);
	COUTPUT << "result is " << result << endl;
    return Py_BuildValue("k", result);        /* convert C -> Python */
    
}

static PyObject *                                
setEvent(PyObject *self, PyObject *args)          
{       
    
	HANDLE eventHandle;
	BOOL   result;
    
	cout << "\n--In function setEvent." << endl;


    if (! PyArg_Parse(args, "(k)", &eventHandle))  /* convert Python -> C */
	{
		COUTPUT << "Parse parameters of setEvent error!" << endl;
        return NULL;                              /* null=raise exception */
	}

	COUTPUT << "eventHandle : " << "0x" << hex << eventHandle << endl;

    COUTPUT << "call SetEvent" << endl;
    result = SetEvent(eventHandle);
	COUTPUT << "result is " << result << endl;
    return Py_BuildValue("k", result);        /* convert C -> Python */    
}

static PyObject *                                
waitForSingleObject(PyObject *self, PyObject *args)          
{       
    
	HANDLE eventHandle;
	DWORD  dwMilliseconds;
	DWORD   result;
    
	cout << "\n--In function waitForSingleObject." << endl;


    if (! PyArg_Parse(args, "(kk)", &eventHandle,&dwMilliseconds ))  /* convert Python -> C */
	{
		COUTPUT << "Parse parameters of waitForSingleObject error!" << endl;
        return NULL;                              /* null=raise exception */
	}

	COUTPUT << "eventHandle : " << "0x" << hex << eventHandle  \
		    << " | dwMilliseconds : " << dwMilliseconds << endl;

    COUTPUT << "call WaitForSingleObject" << endl;
    result = WaitForSingleObject(eventHandle, dwMilliseconds);
	COUTPUT << "result is " << "0x" << hex << result << endl;
    return Py_BuildValue("k", result);        /* convert C -> Python */    
}


static PyObject *                                
closeHandle(PyObject *self, PyObject *args)          
{       
    
	HANDLE handle;
	BOOL   result;
    
	cout << "\n--In function closeHandle." << endl;

    if (! PyArg_Parse(args, "(k)", &handle))  /* convert Python -> C */
	{
		COUTPUT << "Parse parameters of closeHandle error!" << endl;
        return NULL;                              /* null=raise exception */
	}

	COUTPUT << "handle : " << "0x" << hex << handle << endl;

    COUTPUT << "call CloseHandle" << endl;
    result = CloseHandle(handle);
	COUTPUT << "result is "  << result << endl;
    return Py_BuildValue("k", result);        /* convert C -> Python */
    
}




/* registration table  */
static struct PyMethodDef HS_methods[] = {
    {"createEvent", createEvent,METH_VARARGS},       // mulitiple args
    {"resetEvent", resetEvent,METH_VARARGS},               
    {"setEvent", setEvent,METH_VARARGS},         
    {"waitForSingleObject", waitForSingleObject,METH_VARARGS},       
    {"closeHandle", closeHandle,METH_VARARGS},
    {NULL, NULL}                   /* end of table marker */
};

extern "C" {
/* module initializer */
void initWinModule(  )                       /* called on first import */
{                                      /* name matters if loaded dynamically */
    (void) Py_InitModule("WinFile_Event", HS_methods);   /* mod name, table ptr */
	

}

}